package eu.clarin.cmdi.mdservice.action;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.util.HashMap;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import eu.clarin.cmdi.mdservice.internal.Cache;
import eu.clarin.cmdi.mdservice.internal.Utils;
import eu.clarin.cmdi.mdservice.model.Diagnostic;
import eu.clarin.cmdi.mdservice.model.Query;
import eu.clarin.cmdi.mdservice.model.Repositories;
import eu.clarin.cmdi.mdservice.model.WorkspaceProfile;
import eu.clarin.cmdi.mdservice.proxy.MDRepoProxy;
import eu.clarin.cmdi.mdservice.proxy.Pz2Proxy;
import eu.clarin.cmdi.mdservice.proxy.SRUProxy;




public class SRUAction extends RepoAction 
{

	private static final long serialVersionUID = 1L;
	
	/** 
	 * Properties to be filled by Struts with according request-parameters
	 */	
	
	private static int OP_SEARCHRETRIEVE = 1;
	private static int OP_EXPLAIN = 2;
	private static int OP_SCAN = 3;
	
	
	//TODO cache after analysis ?
	/*
	@Override
	public String getCache() {
		return Cache.SKIP;
	}
	*/
	
	@Override
	public String getRepository() {
		/*
		if (getParams().get("repository") == null){
			return getParam("x-cmd-repository");
		}
		return getParam("repository");
		*/
		if (getParams().get("x-context") == null){
			return getParam("x-cmd-repository");
		}
		return getParam("x-context");
	}
	
	@Override
	public String getFormat() {
		if (getParams().get("format") == null){
			if (getParams().get("x-cmd-format") == null){
				return "xml";
			}
			return getParam("x-cmd-format");
		}
		return getParam("format");
	}
	
	/*
	public String getOperation() {
		if (getParams().get("operation") == null){
			return "searchRetrieve";
		}
		return getParam("operation");
	}
	*/
	 protected final static HashMap<String,Integer> operation_code = new HashMap<String,Integer>();
	 static
	 {	 
		 operation_code.put("searchRetrieve", OP_SEARCHRETRIEVE);
		 operation_code.put("explain", OP_EXPLAIN);
		 operation_code.put("scan", OP_SCAN);
	 }
	 
	/**
	 * primitive identification of the target-proxy
	 * base for finding the right base_url in the props
	 * subclass has to override with its specific proxykey
	 * @return
	 */
	public String getProxyKey() {
		return "";
	}
	
	
	@Override
	public void setTargetProxy(){
		
		//Query query = new Query();
		switch (Repositories.RepositoryType.toRepositoryType(Repositories.getRepositories().getRepositoryType(getRepository())))
		{		
		    case PAZPAR: 
		    	setTargetProxy(new Pz2Proxy(new Query(getActionkey(), this.getParams())));
		    	return;
		    case SRU:
		    	setTargetProxy(new SRUProxy(new Query(Query.SRUEXTERN,getParams())));
		    	return;
		    case MD:
		    	setTargetProxy(new MDRepoProxy(new Query(Query.RECORDSET,getParams())));
		    	return;	
		    default:
		    	//TODO error  = bad workspaceProfile configuration
		    	getDiagnostics().Add(Diagnostic.SYSTEM_ERROR, "Error in workspaceprofile configuration", "repository=" + getRepository() );
		}
}
}