package eu.clarin.cmdi.mdservice.action;

import java.io.IOException;
import java.io.InputStream;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.xpath.XPathExpressionException;

import org.apache.log4j.Logger;
import org.w3c.dom.DOMException;
import org.xml.sax.SAXException;

import eu.clarin.cmdi.mdservice.internal.CQLParseException;
import eu.clarin.cmdi.mdservice.internal.Cache;
import eu.clarin.cmdi.mdservice.internal.NoStylesheetException;
import eu.clarin.cmdi.mdservice.model.WorkspaceProfile;
import eu.clarin.cmdi.mdservice.proxy.WorkspaceProxy;


/**
 *
 * @author 
 *
 */
public class WorkspaceAction extends GenericAction 
{

	private static final long serialVersionUID = 1L;
	private static Logger log = Logger.getLogger("WorkspaceAction");
	
	/** 
	 * Properties to be filled by Struts with according request-parameters
	 */	
	//private String actionkey;
	private String data;
	private String type;  //workspacetype	
	//TODO
	private String qid;
	private String qsid;
	
	public String getData(){
		return data;
	}

	public void setData(String data) {
		this.data = data;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}
	
	public String getQid() {
		return qid;
	}
	
	public void setQid(String qid) {
		this.qid = qid;
	}

	public void setQsid(String qsid) {
		this.qsid = qsid;
	}
	
	public String getQsid() {
		return qsid;
	}
	
	/**
	 * primitive identification of the target-proxy
	 * base for finding the right base_url in the props
	 * subclass has to override with its specific proxykey
	 * @return
	 */
	public static String getProxyKey() {
		return "workspaceprofile";
	}

	@Override
	public String getActionContentType() {
		if (this.getFormat().toLowerCase().startsWith("json")) {
			this.setActionContentType("application/json");		
		} else {
			this.setActionContentType("text/xml");	
		}
		
		return getActionContentType();
	}
	
	@Override
	protected void setDefaultParams(){
		if (getFormat().equals("")){
			addParam("format", this.format);
		}
		if (params.get("cache") == null){
			addParam("cache",Cache.SKIP);
		} 
		addParam("fullformat",getFullFormat());
	}	

	@Override
	public String getFullFormat() {
		return "xml2" + getFormat();
	}

	@Override
	public String getUserName(){
		String userstring;
		if (getType().toLowerCase().equals(WorkspaceProfile.SERVER)){
			userstring = WorkspaceProfile.SERVER;
		}else {
			userstring = getServletRequest().getRemoteUser();
			if (userstring == null){
				userstring = "default";
			}
		}
		return userstring;
	}
	
	public Object getVcrid() throws XPathExpressionException{
		/*
		XPathFactory factory = XPathFactory.newInstance(); 
	    XPath xpath = factory.newXPath(); 
	    XPathExpression expr1, expr2;
			//expr = xpath.compile("item[id='" + this.qid + "']/vcrid");
			expr1 = xpath.compile("//Profiles/WorkspaceProfiles/WorkspaceProfile/Querysets/item/Queries/item[id='" + this.qid + "']/vcrid");
			expr2 = xpath.compile("//Profiles/WorkspaceProfiles/WorkspaceProfile/Bookmarksets/item[id='" + this.qid + "']/vcrid");
		    
			//expression is evaluated with respect to a certain context node which is doc.
			Object result = null;
			try{
		        result = expr1.evaluate(workspace_doc, XPathConstants.STRING);
			} catch(Exception e){
				
			}
			if (result.equals("")){
				try{
			        result = expr2.evaluate(workspace_doc, XPathConstants.STRING);
				} catch(Exception e){
					
				}
			}
	     return result;
	     */
		return null;
	}
	
	@Override
	public void setTargetProxy() {
		setTargetProxy(new WorkspaceProxy());
	}
	
	@Override
	public InputStream getSourceStream() throws IOException {
		try {
			return getTargetProxy().getSourceStream();
		} catch (NoStylesheetException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (CQLParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
		/*
		WorkspaceProfile wsp = WorkspaceProfile.getWorkspaceProfile();
		wsp.setUsername(this.getUserName());
		;
		try {
			return wsp.getXMLStream(wsp.getXPathExpressionDummy(WorkspaceProfile.XPATH_EXPR_WORKSPACE, getUserName()));
		} catch (XPathExpressionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (TransformerConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (TransformerException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (TransformerFactoryConfigurationError e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
		*/
	}
		
	public String save() throws ParserConfigurationException, SAXException, IOException, DOMException, XPathExpressionException, TransformerException, TransformerFactoryConfigurationError{
		
		String newid = WorkspaceProfile.getWorkspaceProfile().save(getData());
		this.setResultStream(WorkspaceProfile.createStream(newid));
		
		
		return SUCCESS;
		
	}
	

}