package eu.clarin.cmdi.mdservice.proxy;

import java.io.IOException;
import java.net.URL;

import org.apache.log4j.Logger;

/**
 * Base class for implementation of proxies to target systems.
 * This is now (after rework 2011-09) decoupled from the called Action. 
 * 
 * Defines the methods used for retrieving the data 
 * and provides basic implementation where possible.
 *
 *  
 * @author vronk
 *
 */
public class LocalProxy extends BasicProxy{

	private static final long serialVersionUID = 1L;
	private static Logger log = Logger.getLogger("LocalProxy");
 
	private String proxy_key = "local";

	
	/**
	 * identification of the target-proxy (type)
	 * base for finding the right base_url in the props
	 * subclass has to override with its specific proxykey
	 * @return
	 */
	public String getProxyKey() {				
			return proxy_key;		
	}

		
	/**
	 * forms a URL  to get the local resource
	 * @return the URL to the local resource, as required by the q-param
	 * @throws Exception 
	 */	
	public URL getTargetRequest() throws IOException {
		
		URL targetURL = new URL(getBaseURL(), getParam("q") + ".xml");
		
		log.debug("getTargetRequest().targetURL:" + targetURL);
	    return targetURL;
		
	}


}	