﻿<?xml version="1.0"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:diag="http://www.loc.gov/zing/srw/diagnostic">

<!-- 
<purpose>a (wannabe) robust/generic stylesheet to display "static" content (xml) as html.
it shall operate on the internal xml-files, with special processing of some elements (mainly processing <a>-elements!)</purpose>
<params>
<param name=""></param>
</params>
<history>
	<change on="2011-09-01" type="created" by="vr">based on test2view</change>	
	
</history>
-->

<xsl:include href="cmd_commons.xsl"/> 

<!--<xsl:param name="title" select="if (//div[1][@class='title']) then concat('CMDRSB: ', //div[1][@class='title']) else 'CMDRSB docs'" />-->
<xsl:param name="title" select="if (//div[1][@class='title']) then //div[1][@class='title'] else ''" />

	
<!--<xsl:output method="html" encoding="UTF-8"/>-->

<xsl:template name="continue-root">
<!--	<xsl:copy-of select="." />-->
		<xsl:apply-templates  />
</xsl:template>

<xsl:template match="a[contains(@class,'template')]">

 	<xsl:choose>			
			<xsl:when test="@href='query-input'">
					<xsl:call-template name="query-input" />					
			</xsl:when>
			<xsl:when test="@href='query-list'">
					<xsl:call-template name="query-list" />					
			</xsl:when>
			<xsl:when test="@href='detail-space'">
					<xsl:call-template name="detail-space" />					
			</xsl:when>
			<xsl:when test="@href='public-space'">
					<xsl:call-template name="public-space" />					
			</xsl:when>
			<xsl:when test="@href='user-space'">
					<xsl:call-template name="user-space" />					
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy-of select="."  />				
			</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template match="a[contains(@class,'query') or contains(@class,'request')]">

 <xsl:variable name="specific_prefix" select="if (contains(@href,'query')) then 'search/htmlpage' else ''" />
 
 <xsl:variable name="target_url" >
 	<xsl:choose>			
			<xsl:when test="@class='request count'">
					<xsl:copy-of select="concat($base_url,@href)" /> 					
			</xsl:when>
			<xsl:when test="@class='query count'">
					<xsl:copy-of select="concat($base_url, 'search/xml', @href)" />										
			</xsl:when>
			<xsl:when test="@class='request'">
					<xsl:copy-of select="concat($base_url, @href)"  />										
			</xsl:when>
					
			<xsl:when test="@class='query'">
					<xsl:copy-of select="concat($base_url, 'search/htmltable', @href)"  />										
			</xsl:when>
			<xsl:when test="starts-with(@href,'http:')">
					<xsl:copy-of select="."  />										
			</xsl:when>
			<!--  if it is just a simple a-element (not marked explicitly with 'request' or 'query' class, just pass it through - do not resolve-->				
			<xsl:otherwise>
<!--					<xsl:copy-of select="document(concat($base_url, @href))"  />-->
					<xsl:copy-of select="."  />
			</xsl:otherwise>
		</xsl:choose>	
 </xsl:variable>
<xsl:message>static2view: <xsl:value-of select="concat(@class, ':', $target_url)" /></xsl:message>
<xsl:variable name="data" >
	<xsl:choose>
		<xsl:when test="doc-available($target_url)" >
			<xsl:choose>			
					<xsl:when test="contains(@class,'request') or contains(@class, 'query')">
							<xsl:copy-of select="document($target_url)" />					
					</xsl:when>
					<xsl:otherwise >
							<xsl:copy-of select="." />
					</xsl:otherwise>
					
			</xsl:choose>					
		</xsl:when>
		<xsl:otherwise>
			<diagnostics>
			<diag:diagnostic>
				<diag:message>Document not available!</diag:message>
			</diag:diagnostic>
			</diagnostics>
		</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
	
 <div class="cmds-ui-block" >
   <xsl:if test="not(contains(@class,'no-header'))" >
	 <div class="ui-widget-header">
		<xsl:value-of select="@class" />: <xsl:copy-of select="." /> [<a href="{concat($base_url,$specific_prefix,@href)}" ><xsl:value-of select="@href" /></a>]
	</div>	
   </xsl:if>
	
	<div class="ui-widget-content">
		<xsl:choose>
			<xsl:when test="exists($data/diagnostics)">
				<span class="error" >
					<xsl:value-of select="$data/diagnostics/diag:diagnostic/diag:message" />
				</span>
			</xsl:when>
			<xsl:when test="@class='request count'">
				root: <xsl:value-of select="$data/*/name()" />|<xsl:value-of select="count($data//*)" />|
			</xsl:when>
			<xsl:when test="@class='query count'">
							number of records: <xsl:value-of select="$data//numberOfRecords" />
			</xsl:when>
			
			<!-- <xsl:when test="@class='query'">
					<xsl:variable name="data" select="document(concat($base_url,'recordset/htmltable/', @href))" />
					<xsl:copy-of select="$data" />
			</xsl:when> -->		
			<xsl:otherwise>
<!--					<xsl:apply-templates select="$data" mode="process-result"/>-->				
					<xsl:copy-of select="$data" />
			</xsl:otherwise>
		</xsl:choose>
				
	</div>
 </div>
</xsl:template>

<xsl:template match="*|@*">
	<xsl:copy>
		<xsl:apply-templates select="node()|@*" />
	</xsl:copy>	
</xsl:template>

<xsl:template match="*|@*" mode="process-result" >
	<xsl:copy>
		<xsl:apply-templates select="node()|@*" mode="process-result" />
	</xsl:copy>	
</xsl:template>

<!-- 
 <diagnostics>
	<diagnostic xmlns="http://www.loc.gov/zing/srw/diagnostic">
    <uri>info:srw/diagnostic/1/1</uri>    
    <message>Exception occurred: Connection refused: connect</message> 
-->
<xsl:template match="diagnostics" mode="process-result" >
	<div class="error" >
		 <xsl:value-of select="diag:diagnostic/diag:message" />
	</div>	
</xsl:template>


</xsl:stylesheet>
  